--- old/usr/src/cmd/svc/svcadm/svcadm.c	Mon Dec  4 17:58:50 2017
+++ new/usr/src/cmd/svc/svcadm/svcadm.c	Mon Dec  4 17:58:50 2017
@@ -25,6 +25,7 @@
 
 /*
  * Copyright 2015, Joyent, Inc. All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 /*
@@ -1931,6 +1932,13 @@
 		return (0);
 	}
 
+	if ((flags & MARK_TEMPORARY) == 0) {
+		uu_warn(gettext("Instance \"%s\" cannot be degraded "
+		    "permantently.\n"), wip->fmri);
+		exit_status = 1;
+		return (0);
+	}
+
 	set_inst_action(wip->fmri, wip->inst, (flags & MARK_IMMEDIATE) ?
 	    SCF_PROPERTY_DEGRADE_IMMEDIATE : SCF_PROPERTY_DEGRADED);
 
@@ -2507,11 +2515,7 @@
 			usage();
 
 		if (strcmp(argv[optind], "degraded") == 0) {
-			if (flags & MARK_TEMPORARY)
-				uu_xdie(UU_EXIT_USAGE, gettext("-t may not be "
-				    "used with degraded.\n"));
 			callback = force_degraded;
-
 		} else if (strcmp(argv[optind], "maintenance") == 0) {
 			callback = force_maintenance;
 		} else {
@@ -2529,7 +2533,7 @@
 			usage();
 
 		if ((err = scf_walk_fmri(h, argc, argv, WALK_FLAGS, callback,
-		    NULL, &exit_status, pr_warn)) != 0) {
+		    (void *)flags, &exit_status, pr_warn)) != 0) {
 			pr_warn(gettext("failed to iterate over "
 			    "instances: %s\n"),
 			    scf_strerror(err));
